Attribute VB_Name = "MMain"
'*********************************************************************
' Module:       MMain
' Author:       Craig Jasper, Jr.
' Machine:      CRAIG [ID: CP4850] | Windows 2000 Server.
' Notes:        Written in VB6 Enterprise Edition with
'               SP4 installed.
'*********************************************************************

Option Explicit

Public Declare Function CloseHandle Lib "Kernel32.dll" _
(ByVal Handle As Long) As Long

Public Declare Function GetClassName Lib _
"user32" Alias "GetClassNameA" _
(ByVal hWnd As Long, _
ByVal lpClassName As String, _
ByVal nMaxCount As Long) As Long

Public Declare Function GetCursorPos Lib "user32" _
(lpPoint As POINTAPI) As Long

Public Declare Function GetModuleFileNameExA Lib "psapi.dll" _
(ByVal hProcess As Long, _
ByVal hModule As Long, _
ByVal ModuleName As String, _
ByVal nSize As Long) As Long

Public Declare Function GetParent Lib "user32" _
(ByVal hWnd As Long) As Long

Public Declare Function GetSystemDirectory Lib _
"kernel32" Alias "GetSystemDirectoryA" _
(ByVal lpBuffer As String, _
ByVal nSize As Long) As Long

Public Declare Function GetWindowsDirectory Lib _
"kernel32" Alias "GetWindowsDirectoryA" _
(ByVal lpBuffer As String, _
ByVal nSize As Long) As Long

Public Declare Function GetWindowRect Lib "user32" _
(ByVal hWnd As Long, _
lpRect As RECT) As Long

Public Declare Function GetWindowText Lib _
"user32" Alias "GetWindowTextA" _
(ByVal hWnd As Long, _
ByVal lpString As String, _
ByVal cch As Long) As Long

Public Declare Function GetWindowThreadProcessId Lib "user32" _
(ByVal hWnd As Long, _
lpdwProcessId As Long) As Long

Public Declare Function IsWindow Lib "user32" _
(ByVal hWnd As Long) As Long

Public Declare Function OpenProcess Lib "Kernel32.dll" _
(ByVal dwDesiredAccessas As Long, _
ByVal bInheritHandle As Long, _
ByVal dwProcId As Long) As Long

Public Declare Function SetWindowPos Lib "user32" _
(ByVal hWnd As Long, _
ByVal hWndInsertAfter As Long, _
ByVal X As Long, _
ByVal Y As Long, _
ByVal cx As Long, _
ByVal cy As Long, _
ByVal wFlags As Long) As Long

Public Declare Function ShellExecute Lib _
"shell32.dll" Alias "ShellExecuteA" _
(ByVal hWnd As Long, _
ByVal lpOperation As String, _
ByVal lpFile As String, _
ByVal lpParameters As String, _
ByVal lpDirectory As String, _
ByVal nShowCmd As Long) As Long

Public Declare Function WindowFromPoint Lib "user32" _
(ByVal xPoint As Long, _
ByVal yPoint As Long) As Long

Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const HWND_BOTTOM = 1

Private Const MAX_PATH = 260

Public Const PROCESS_QUERY_INFORMATION = 1024
Public Const PROCESS_VM_READ = 16

Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE

Public Const SW_SHOW = 5

Public Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type RECT
  Left    As Long
  Top     As Long
  Right   As Long
  Bottom  As Long
End Type

Public Sub Main()
  On Error GoTo PROC_ERR
  
  Screen.MousePointer = vbHourglass
  Load frmSysInfo
  Screen.MousePointer = vbDefault
  
  Exit Sub
PROC_ERR:
  MsgBox ErrorString("Main"), vbExclamation
End Sub

'*********************************************************************
' Routine:      ErrorString
' Description:  Returns custom error string.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' strRoutine    String. Name of the calling routine.
'*********************************************************************
Public Function ErrorString(strRoutine As String) As String
  ErrorString = "The following error has occured:" & vbCrLf & vbCrLf & _
     "Routine: " & strRoutine & vbCrLf & _
     "Error Description: " & Err.Description & vbCrLf & _
     "Error Number: " & Err.Number
End Function

'*********************************************************************
' Routine:      RandomLink
' Description:  Returns a random link.
' Notes:        The links below are in alphabetical
'               order and aren't put into the order of sites
'               that I like best...
'*********************************************************************
Public Function RandomLink() As String
  On Error GoTo PROC_ERR
  
  Dim strURL(1 To 6)  As String
  Dim intRandom       As Integer
  
  strURL(1) = "http://abstractvb.com/"
  strURL(2) = "http://msdn.microsoft.com/vbasic"
  strURL(3) = "http://www.desaware.com"
  strURL(4) = "http://www.devx.com"
  strURL(5) = "http://www.patorjk.com"
  strURL(6) = "http://www.planet-source-code.com/vb/"
    
  Randomize
  intRandom = Int(UBound(strURL) * Rnd) + 1
  RandomLink = strURL(intRandom)
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("RandomLink"), vbExclamation
End Function

'*********************************************************************
' Routine:      LaunchURL
' Description:  Launchs a URL.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. hWnd of calling form.
' strAddress    String. URL to launch.
'*********************************************************************
Public Sub LaunchURL _
     (hWnd As Long, _
     strAddress As String)

  On Error GoTo PROC_ERR
  
  Dim lngRet As Long
  
  Screen.MousePointer = vbHourglass
  lngRet = ShellExecute(hWnd, "Open", strAddress, _
     vbNullString, CurDir$, SW_SHOW)
     
  Screen.MousePointer = vbDefault
  
  If lngRet < 32 Then
    frmSysInfo.lblURL(0).ForeColor = vbBlue
    MsgBox "LaunchURL routine failed.", vbExclamation
  End If

  Exit Sub
PROC_ERR:
  MsgBox ErrorString("LaunchURL"), vbExclamation
  Screen.MousePointer = vbDefault
End Sub

'*********************************************************************
' Routine:      SetTopMostWindow
' Description:  Keeps window on top.
' Notes:        Review
'               http://support.microsoft.com/support/kb/articles/Q150/2/33.ASP
'               or the related documents for important information.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to set topmost.
' bloTopMost    Boolean. True to set topmost, false otherwise.
'*********************************************************************
Public Function SetTopMostWindow _
     (hWnd As Long, _
     bloTopMost As Boolean) As Long
    
  On Error GoTo PROC_ERR

  If IsWindow(hWnd) Then
    If bloTopMost Then
      SetTopMostWindow = SetWindowPos(hWnd, _
         HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
    Else
      SetTopMostWindow = SetWindowPos(hWnd, _
         HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
    
      SetTopMostWindow = False
    End If
  End If

  Exit Function
PROC_ERR:
  MsgBox ErrorString("SetTopMostWindow"), vbExclamation
End Function

'*********************************************************************
' Routine:      CurrentHandle
' Description:  Returns the handle that mouse is over.
'*********************************************************************
Public Function CurrentHandle() As Long
  On Error GoTo PROC_ERR
  
  Dim POINT As POINTAPI
  
  Call GetCursorPos(POINT)
  CurrentHandle = WindowFromPoint(POINT.X, POINT.Y)
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("CurrentHandle"), vbExclamation
End Function

'*********************************************************************
' Routine:      GetCaption
' Description:  Returns caption of hWnd.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function GetCaption(hWnd As Long) As String
  On Error GoTo PROC_ERR
  
  Dim lngRet      As Long
  Dim strCaption  As String * 100
  
  lngRet = GetWindowText(hWnd, strCaption, 100)
  GetCaption = Left$(strCaption, lngRet)
  
  If GetCaption = "" Then GetCaption = "N/A"
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("GetCaption"), vbExclamation
End Function

'*********************************************************************
' Routine:      ClassName
' Description:  Returns class name of hWnd.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function ClassName(hWnd As Long) As String
  On Error GoTo PROC_ERR
  
  Dim lngRet    As Long
  Dim strClass  As String * 100

  lngRet = GetClassName(hWnd, strClass, 100)
  ClassName = Left$(strClass, lngRet)
    
  Exit Function
PROC_ERR:
  MsgBox ErrorString("ClassName"), vbExclamation
End Function

'*********************************************************************
' Routine:      WindowSize
' Description:  Returns window size.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function WindowSize(hWnd As Long) As String
  On Error GoTo PROC_ERR

  Dim RECT       As RECT
  Dim lngLeft    As Long
  Dim lngTop     As Long
  Dim lngHeight  As Long
  Dim lngWidth   As Long

  Call GetWindowRect(hWnd, RECT)
  
  lngLeft = RECT.Left
  lngTop = RECT.Top
  lngHeight = (RECT.Bottom - RECT.Top) * Screen.TwipsPerPixelY
  lngWidth = (RECT.Right - RECT.Left) * Screen.TwipsPerPixelX
  
  WindowSize = "Window Left Position: " & CStr(lngLeft) & vbCrLf & _
     "Window Top Position: " & CStr(lngTop) & vbCrLf & _
     "Window Height: " & CStr(lngHeight) & vbCrLf & _
     "Window Width: " & CStr(lngWidth)
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("WindowSize"), vbExclamation
End Function

'*********************************************************************
' Routine:      GetPath
' Description:  Obtains the path of running process.
' Notes:        This is for Windows NT/2000 ONLY and has not been
'               tested under the Win 95/98 Kernel.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function GetPath(hWnd As Long) As String
  On Error GoTo PROC_ERR

  Dim strModuleName             As String
  Dim lngInstance               As Long
  Dim lngRet                    As Long
  Dim lngProcessHandle          As Long
  Dim lngModuleHandle           As Long
  Dim lngThreadProcessID        As Long
  Dim lngHoldProcessHandle      As Long

  lngThreadProcessID = GetWindowThreadProcessId(hWnd, _
     lngHoldProcessHandle)
      
  lngProcessHandle = OpenProcess(PROCESS_QUERY_INFORMATION _
     Or PROCESS_VM_READ, 0&, lngHoldProcessHandle)

  If lngProcessHandle <> 0 Then
    strModuleName = Space(MAX_PATH)
        
    lngRet = GetModuleFileNameExA(lngProcessHandle, _
       lngModuleHandle, strModuleName, Len(strModuleName))
        
    GetPath = Left(strModuleName, lngRet)
    
    If GetPath = "" Then GetPath = "Windows NT/2000 Only Routine"
  End If

  lngRet = CloseHandle(lngProcessHandle)
      
  Exit Function
PROC_ERR:
  MsgBox ErrorString("GetPath"), vbExclamation
End Function

'*********************************************************************
' Routine:      ParentHandle
' Description:  Returns the parent handle.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function ParentHandle(hWnd As Long) As Long
  ParentHandle = GetParent(hWnd)
End Function

'*********************************************************************
' Routine:      ParentWindowText
' Description:  Returns parent window text.
'*********************************************************************
Public Function ParentWindowText() As String
  On Error GoTo PROC_ERR
  
  Dim lngRet   As Long
  Dim strText  As String * 100

  lngRet = GetWindowText(ParentHandle(CurrentHandle), strText, 100)
  ParentWindowText = Left$(strText, lngRet)
  
  If ParentWindowText = "" Then ParentWindowText = "N/A"
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("ParentWindowText"), vbExclamation
End Function

'*********************************************************************
' Routine:      ParentWindowClassName
' Description:  Returns parent window class name.
'---------------------------------------------------------------------
' Parameters    Type/Description
'---------------------------------------------------------------------
' hWnd          Long. Handle to window.
'*********************************************************************
Public Function ParentWindowClassName(hWnd As Long) As String
  On Error GoTo PROC_ERR
  
  Dim lngRet    As Long
  Dim strClass  As String * 100
  
  lngRet = GetClassName(ParentHandle(CurrentHandle), strClass, 100)
  ParentWindowClassName = Left$(strClass, lngRet)
  
  If ParentWindowClassName = "" Then ParentWindowClassName = "N/A"
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("ParentWindowClassName"), vbExclamation
End Function

'*********************************************************************
' Routine:      SysDir
' Description:  Returns the system directory.
'*********************************************************************
Public Function SysDir() As String
  Dim lngRet As Long
  Dim strDir As String * MAX_PATH
  
  lngRet = GetSystemDirectory(strDir, MAX_PATH)
  SysDir = Left$(strDir, lngRet)
End Function

'*********************************************************************
' Routine:      WinDir
' Description:  Returns windows directory.
'*********************************************************************
Public Function WinDir() As String
  Dim lngRet As Long
  Dim strDir As String * MAX_PATH
  
  lngRet = GetWindowsDirectory(strDir, MAX_PATH)
  WinDir = Left$(strDir, lngRet)
End Function

'*********************************************************************
' Routine:      WindowInformation
' Description:  Returns String with current window information.
'*********************************************************************
Public Function WindowInformation() As String
  On Error GoTo PROC_ERR
  
  WindowInformation = _
     "Current Handle: " & CStr(CurrentHandle) & vbCrLf & _
     "Current Class Name: " & CStr(ClassName(CurrentHandle)) & vbCrLf & _
     "Current Caption: " & GetCaption(CurrentHandle) & vbCrLf & _
     "Parent Window Handle: " & ParentHandle(CurrentHandle) & vbCrLf & _
     "Parent Window Class Name: " & ParentWindowClassName(CurrentHandle) & vbCrLf & _
     "Parent Window Text: " & ParentWindowText & vbCrLf & _
     WindowSize(CurrentHandle) & vbCrLf & _
     "Module Name: " & GetPath(CurrentHandle)
  
  Exit Function
PROC_ERR:
  MsgBox ErrorString("WindowInformation"), vbExclamation
End Function
